(function() {
  var UB, UtilityBelt;
  UtilityBelt = (function() {
    function UtilityBelt() {
      this.types = ['Array', 'Boolean', 'Date', 'Function', 'Number', 'Object', 'RegExp', 'String'];
      this.methods = ['is_array', 'is_ary', 'is_boolean', 'is_bool', 'is_date', 'is_float', 'is_function', 'is_func', 'is_hash', 'is_integer', 'is_int', 'is_null', 'is_number', 'is_object', 'is_obj', 'is_regexp', 'is_string', 'is_str', 'is_empty', 'to_array', 'to_boolean', 'to_float', 'to_integer', 'to_string'];
    }
    UtilityBelt.prototype.deploy = function(types) {
      var JSObject, i, j;
      if (UtilityBelt.is_empty(types)) {
        types = this.types;
      }
      for (i in types) {
        JSObject = eval("" + types[i]);
        for (j in this.methods) {
          if (UtilityBelt.is_function(UtilityBelt[this.methods[j]]) && UtilityBelt.is_empty(JSObject.prototype[this.methods[j]])) {
            eval("" + types[i] + ".prototype." + this.methods[j] + " = function () { return UtilityBelt." + this.methods[j] + "(this); };");
          }
        }
      }
      Array.prototype.is_equal = function(value) {
        var num, _ref;
        if (typeof value === 'undefined' || value === null || typeof value.length !== 'number' || this.length !== value.length) {
          return false;
        }
        for (num = _ref = this.length; _ref <= 0 ? num <= 0 : num >= 0; _ref <= 0 ? num++ : num--) {
          if (typeof this[num] !== 'undefined' && this[num].is_array() && typeof value[num] !== 'undefined' && value[num].is_array()) {
            if (!this[num].is_equal(value[num])) {
              return false;
            }
          } else {
            if (this[num] !== value[num]) {
              return false;
            }
          }
        }
        return true;
      };
      Number.prototype.times_do = function(block) {
        var count, num, _results, _results2;
        count = Math.floor(this.valueOf());
        if (block.is_string()) {
          _results = [];
          for (num = count; count <= 1 ? num <= 1 : num >= 1; count <= 1 ? num++ : num--) {
            _results.push(eval(block));
          }
          return _results;
        } else if (block.is_function()) {
          _results2 = [];
          for (num = count; count <= 1 ? num <= 1 : num >= 1; count <= 1 ? num++ : num--) {
            _results2.push(block(num));
          }
          return _results2;
        }
      };
      return null;
    };
    /*
      All Types
      */
    UtilityBelt.is_array = function(value) {
      return value instanceof Array;
    };
    UtilityBelt.is_ary = function(value) {
      return UtilityBelt.is_array(value);
    };
    UtilityBelt.is_boolean = function(value) {
      return value instanceof Boolean;
    };
    UtilityBelt.is_bool = function(value) {
      return UtilityBelt.is_boolean(value);
    };
    UtilityBelt.is_date = function(value) {
      return value instanceof Date;
    };
    UtilityBelt.is_float = function(value) {
      return UtilityBelt.is_number(value) && Math.floor(value) !== value.valueOf();
    };
    UtilityBelt.is_function = function(value) {
      return typeof value === 'function' && !UtilityBelt.is_regexp(value);
    };
    UtilityBelt.is_func = function(value) {
      return UtilityBelt.is_function(value);
    };
    UtilityBelt.is_hash = function(value) {
      return UtilityBelt.is_object(value) && !(UtilityBelt.is_null(value) || UtilityBelt.is_array(value) || UtilityBelt.is_boolean(value) || UtilityBelt.is_date(value) || UtilityBelt.is_function(value) || UtilityBelt.is_number(value) || UtilityBelt.is_regexp(value) || UtilityBelt.is_string(value));
    };
    UtilityBelt.is_integer = function(value) {
      return UtilityBelt.is_number(value) && Math.floor(value) === value.valueOf();
    };
    UtilityBelt.is_int = function(value) {
      return UtilityBelt.is_integer(value);
    };
    UtilityBelt.is_null = function(value) {
      return value === null;
    };
    UtilityBelt.is_number = function(value) {
      return value instanceof Number;
    };
    UtilityBelt.is_object = function(value) {
      return value instanceof Object;
    };
    UtilityBelt.is_obj = function(value) {
      return UtilityBelt.is_object(value);
    };
    UtilityBelt.is_regexp = function(value) {
      return value instanceof RegExp;
    };
    UtilityBelt.is_string = function(value) {
      return value instanceof String;
    };
    UtilityBelt.is_str = function(value) {
      return UtilityBelt.is_string(value);
    };
    UtilityBelt.is_date_empty = function(value) {
      return UtilityBelt.is_date(value) && value.valueOf() === 0;
    };
    UtilityBelt.is_object_empty = function(value) {
      return UtilityBelt.is_object(value) && value.length === 0;
    };
    UtilityBelt.is_empty = function(value) {
      return (typeof value === 'undefined' || value === null || UtilityBelt.is_date_empty(value) || UtilityBelt.is_object_empty(value)) && !UtilityBelt.is_function(value);
    };
    UtilityBelt.to_array = function(value) {
      if (UtilityBelt.is_array(value)) {
        return value.valueOf();
      }
      if (UtilityBelt.is_date(value)) {
        return [value];
      }
      return [value.valueOf()];
    };
    UtilityBelt.to_boolean = function(value) {
      if (UtilityBelt.is_boolean(value)) {
        return value.valueOf();
      }
      if (UtilityBelt.is_function(value)) {
        return UtilityBelt.to_boolean(value());
      }
      if (UtilityBelt.is_number(value) && value.valueOf() === 0) {
        return false;
      }
      if (!UtilityBelt.is_empty(value)) {
        return true;
      }
      return false;
    };
    UtilityBelt.to_float = function(value) {
      var test;
      if (UtilityBelt.is_float(value)) {
        return value.valueOf();
      }
      if (UtilityBelt.is_integer(value)) {
        return value.valueOf() + 0.000000000000001;
      }
      if (UtilityBelt.is_function(value)) {
        return UtilityBelt.to_float(value());
      }
      if (UtilityBelt.is_date(value)) {
        return value.valueOf() + 0.001;
      }
      if (UtilityBelt.is_boolean(value) && value.valueOf() === true) {
        return 1.000000000000001;
      }
      if (typeof value.toString === 'function') {
        test = parseFloat(value.toString());
      } else {
        test = parseFloat(value.valueOf());
      }
      if (UtilityBelt.is_float(test)) {
        return test;
      }
      return 0.000000000000001;
    };
    UtilityBelt.to_integer = function(value) {
      var test;
      if (UtilityBelt.is_integer(value) || UtilityBelt.is_date(value)) {
        return value.valueOf();
      }
      if (UtilityBelt.is_float(value)) {
        return Math.round(value.valueOf());
      }
      if (UtilityBelt.is_function(value)) {
        return UtilityBelt.to_integer(value());
      }
      if (UtilityBelt.is_boolean(value) && value.valueOf() === true) {
        return 1;
      }
      if (typeof value.toString === 'function') {
        test = parseInt(value.toString());
      } else {
        test = parseInt(value.valueOf());
      }
      if (UtilityBelt.is_integer(test)) {
        return test;
      }
      return 0;
    };
    UtilityBelt.to_string = function(value) {
      if (UtilityBelt.is_string(value)) {
        return value.valueOf();
      }
      if (UtilityBelt.is_function(value)) {
        return UtilityBelt.to_string(value());
      }
      if (typeof value.toString === 'function') {
        return value.toString();
      }
      return "" + (value.valueOf());
    };
    return UtilityBelt;
  })();
  UB = new UtilityBelt;
  UB.deploy();
  module.exports = UB;
}).call(this);
